

//////////////////////////////////////////////////////////////////
//                                                              //
//           PLINK (c) 2005-2006 Shaun Purcell                  //
//                                                              //
// This file is distributed under the GNU General Public        //
// License, Version 2.  Please see the file COPYING for more    //
// details                                                      //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef __LINEAR_H__
#define __LINEAR_H__

#include<vector>
#include "plink.h"
#include "model.h"

using namespace std;

class LinearModel : public Model {

 public:

  LinearModel();

  void fitLM();

  void noCluster();
  void setCluster(vector<int> & cl);
  void pruneY();
  void setDependent(vector_t & dv);

  void reset();
  vector_t getCoefs();
  vector_t getVar();
  
  void displayResults(ofstream &, Locus *);

 private:

  vector_t Y;
  vector<int> clst;
  vector<int> C;

  vector<double> se;
  double chisq;

  vector<double> sig;
  vector<double> w;
  vector<vector<double> > u;
  vector<vector<double> > v;

  double varY;
  int nc;

  bool cluster;
  void function(const int i, vector<double> & p );  
  void setVariance();
};


#endif
